; Script file set, version 1, for Lotus Notes 4.5 / 4.6x.
; For JFW version 3.2.
; Scriptfile: NLNOTES.jms 
; Program file: LNLNotes.exe. 
; Part of the lotus notes scriptfile set.
; Author: Jim Homme.
; Date Written: October 21, 1996.
; Updated from the Lotus Notes 4.1A macro set. 
; Converted to scripts: November 4, 1997.
; Last modified: August 20, 1998.
; Last modification: Ported JFW 3.0 features over including:
; Auto route of JAWS to PC cursor.

include "hjconst.jsh"
include "hjglobal.jsh"
include "nlnotes.jsh"
include "nlnotes.jsm"

Void Function AutoStartEvent ()

Let DefaultTypingEcho = GetDefaultJCFOption (OPT_TYPING_ECHO) ;init the keyboard typing echo variable.
; Let GlobalMousePixel = 3
; uncomment the next line to have attributes announced
; let AnnounceAttributeChanges=1
; uncomment the next line to turn Autorouting of JAWS cursor on by default
let AutoRouteJAWSToPc=1
FrameClearValues ()
; uncomment this next line if you want reading mode on automatically
; let GlobalReadMode = on

if	DefaultFirstTime == 0 then
	let DefaultFirstTime = 1
	If	GetVerbosity() == BEGINNER then
		SayString (msg371) ;"for screen sensitive help Press insert + f1"
		SayString (msg372) ;"for JAWS Help Keys or help in dialog boxes Press Insert + H"
		SayString (msg373) ;"for a summary of windows short cut keys Press insert + W"
	EndIf
endif

EndFunction

Void Function NewTextEvent (handle hwnd, string buffer, int nAttributes, 
int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

var
	string TheClass

let TheClass = GetWindowClass(hwnd)

;if	TheClass == "NtDsWnd" then
;	SayString(buffer)
;	SayInteger(nTextColor)
;	SayString("on")
;	SayInteger(nBackgroundColor)
;endif

if	sFrameName == "" then
	; this text is not associated with a frame
	SayNonFramedText (hwnd, buffer, nAttributes, 
	nTextColor, nBackgroundColor, nEcho, sFrameName)
else
	; this text is associated with a frame
	if (nEcho == ECHO_NONE) then
		return; frame is being silenced
	endif
	if (nEcho  == ECHO_ALL ||
	   (nAttributes & ATTRIB_HIGHLIGHT)) then
		; if FrameEcho is set to all or the text being written is highlighted
		SayString(buffer)
	endif
endif

EndFunction

Void Function SayNonFramedText (handle hwnd, string buffer, int nAttributes, 
int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

var
	string TheClass

if	(nAttributes& ATTRIB_HIGHLIGHT) then
	let SayHighlightedTextCalled = true
	SayHighlightedText(hwnd,buffer)
	return
endif

let TheClass = GetWindowClass(hwnd)

if	nTextColor == 33534432  then
	if	TheClass == "NotesSubprog"   then
		let SayHighlightedTextCalled = true
;		SayString ("highlighted") 
;		SayInteger(nTextColor)
;		SayString ("on")
;		SayInteger(nBackgroundColor)
		SayHighlightedText(hwnd,buffer)
		return
	endif
endif

;if	nTextColor == 33554432  then
;	if	TheClass == "NotesSubprog"   then
;		let SayHighlightedTextCalled = true
;		SayString ("highlighted") 
;		SayInteger(nTextColor)
;		SayString ("on")
;		SayInteger(nBackgroundColor)
;		SayHighlightedText(hwnd,buffer)
;		return
;	endif
;endif

if	nTextColor == 50331647 then
	if	TheClass == "ListBox"   then
		let SayHighlightedTextCalled = true
		SayHighlightedText(hwnd,buffer)
		return
	endif
endif

;if TheClass == "NotesFieldHelp" then
;	SayString(buffer)
;	return
;endif

SayNonHighlightedText(hwnd,buffer)

EndFunction

Void Function SayNonHighlightedText (handle hwnd, string buffer)
	var
	string TheClass
let TheClass = GetWindowClass(hwnd)
if ((GetScreenEcho() > 1)
   ;wn36="#32771"
   || (TheClass == wn36 )) then
	SayString(buffer)
EndIf

if	TheClass ==  WC01 ; "NotesRichText"
&&	GlobalReadMode == on then
	SayString(buffer) 
	return
endif

if	TheClass == Wc06 ; "SCCDISPLAY"
&&	GlobalReadMode == on then
	SayString(buffer) 
	return
endif


if	TheClass ==  "IRIS.tedit" 
&&	GlobalReadMode == on then
	SayString("formula window")
	SayString(buffer) 
	return
endif

If (TheClass == "tooltips_class32") Then
	let ToolTipsHandle = Hwnd 
	;the if test works only when the jaws cursor is active.
	;To allow the tool tip to be spoken when it is moving across the task tray.
	if (GetActiveCursor () == 0) Then 
	SayWindow (ToolTipsHandle, 0)
	endif
endif

if (GetWindowSubtypeCode (Hwnd) == WT_PASSWORDEDIT) then ;#42
	SayString (buffer)
EndIf

if	TheClass == "IRIS.password" then		
	SayString(Buffer)
endif

if (GetWindowSubTypeCode (hwnd) == WT_TREEVIEW) && (GetTreeViewLevel() !=PreviousTreeviewLevel) then
	SaytreeViewLevel ()
endIf

EndFunction

Function SayFocusedWindow()

var
	int TypeCode,
	int ControlId,
	string Class

let TypeCode = GetWindowSubTypeCode(GlobalFocusWindow)
let Class = GetWindowClass(GlobalFocusWindow)
let ControlId = GetControlID(GlobalFocusWindow)

;  Turn JAWS restriction off when not in views.

if	TypeCode > WT_Unknown then
	ToggleJawsRestriction(off)
elif	ControlID == 1 then ; View / Go to
	JawsCursor()
	RouteJawsToPc()
	ToggleJawsRestriction(on)
	SayLine()
endif

; Toggle read mode off when not in documents, if it's on.

if	Class != wc01 then 
	let GlobalReadMode = off
else
	let GlobalReadMode = GlobalPrevReadMode
endif

if	ReadLabels == OFF then
	SayWindowTypeAndText(GlobalFocusWindow)
endif

EndFunction

; Reading Keys Macros

Script SayNextLine(); {Down Arrow}


NextLine()
PerformScript SayLine()
EndScript

Script SayPriorCharacter(); {Left Arrow}

PriorCharacter ()

ProcessLeftAndRightArrow()

EndScript

Script SayNextCharacter(); {Right Arrow}

NextCharacter()

ProcessLeftAndRightArrow()

EndScript

Script SayPriorLine(); {Up Arrow}

PriorLine()

PerformScript SayLine ()

EndScript



Script ProcessTabKey (); {Tab}


{Tab}

if	CaretVisible() then
;	SayString("Caret visible")
	SayField()
	return
endif

PerformScript nlnotes6()

EndScript

Script nlnotes7(); {Shift+Tab}


{Shift+Tab}

if	CaretVisible() then
;	SayString("Caret visible")
	SayField()
	return
endif

PerformScript nlnotes6()

EndScript

Script ProcessEnterKey () 

if	GetWindowSubTypeCode(GetFocus()) == Wt_Button  then
	RouteJawsToPc()
	LeftMouseButton()
	return
endif

if	GetControlId(GetFocus()) == 1 then
	JawsHome()
	LeftMouseButton()
endif

{enter}

if	CaretVisible() then
	SayField()
	return
endif

if 	not	 IsPcCursor() then
	PcCursor()
endif

PerformScript nlnotes6()

EndScript

Script SayLine ()

; This function gets called when the up or down arrow is pressed.

var
	handle Window,
	string Class
	
pause()

; SayString ("insert + control + shift + f11")

if	not IsPCCursor() then ; Another cursor is active 
;	SayString("not pc cursor")
	SayLine()
	return
endif

if	CaretVisible() then
	let Window = GetFocus()
	let Class = GetWindowClass(Window)
	if	Class == "IRIS.tedit" then
			SayTextBetween(GetWindowLeft(Window), GetWindowRight(Window))
	elif	Class == "NotesODList" then
		return
	else
		SayLine()
		return
	endif
else
	SayLine()
	return
endif

PerformScript nlnotes6()

EndScript
Void Function ProcessLeftAndRightArrow ()

; This function gets called when the left or right arrow is pressed.

if	not IsPCCursor() then
	SayCharacter()
	return
endif

if	CaretVisible() then
	SayCharacter()
	return
endif

PerformScript nlnotes6()

EndFunction

Script nlnotes6(); {insert+control+shift+f9}


; This macro has common code for up and down arrow,
; left and right arrow, tab, shift tab, and enter.

var
	handle Window,
	string Class

;SayString ("insert + shift + control + f9")

let Window = GetFocus()
Let Class = GetWindowClass(Window)

; SayString (Class)
; Refresh()

if	(ReadLabels == on) then
;	SayString("Read labels is on")
	SayToCursor ()
endif

if	(GetWindowTypeCode(Window) == WT_TABCONTROL) then
; 	SayString("Tab control")
	SayWord()
	return
endif

EndScript

Script ActivateLeftPane (); {control + shift + e}

; Move to the left pane.

var
	int Found
;  attempt to find the left window or pane
; Click if found.

if	GlobalMenuMode > MENU_INACTIVE then
	return
endif

if	DialogActive() then
	return
endif

let Found = GoToControl(1000, True) 

if	Found > 0 then
	let GlobalPane = LeftPane
	SayString (msg080) ;"left pane")
	ToggleJawsRestriction(on)	
	return
endif

let Found = GoToControl(1004, True) 

if	Found > 0 then
	let GlobalPane = LeftPane
	SayString (msg080) ;"left pane"
	ToggleJawsRestriction(on)
	return
endif

SayString("left pane not found")

EndScript

Script ActivateRightPane ()

; Move to the right pane.
var
	int Found

if	GlobalMenuMode > MENU_INACTIVE then
	return
endif

if	DialogActive() then
	return
endif

let Found = GoToControl(1001, True) 

if	Found > 0 then
	let GlobalPane = RightPane
	SayString ("right pane")
	ToggleJawsRestriction(on)
	return
endif

let Found = GoToControl(21, True) 

if	Found > 0 then
	let GlobalPane = RightPane
	SayString ("right pane")
	ToggleJawsRestriction(on)
	return
endif

SayString("right pane not found")

EndScript

Script ActivateFullScreen (); {control + shift + w}

; Set back to full-screen mode.

PCCursor()

ToggleJawsRestriction(off)
let GlobalPane = FullScreen
SayString ("full screen")

EndScript

Script LeftMouseButton(); {num pad slash}

;var
;	handle window,
;	string Class	

LeftMouseButton()

if	IsSameScript() then
	let GlobalPane = FullScreen
	ToggleJawsRestriction(off)
	PcCursor()
endif

if	GlobalPane == LeftPane then ; We are switching to a view.
	Delay(10) ; for one second.
	SayString (GetWindowName (GetFocus()))
endif

EndScript

; Scripts For Notes Database Developers

Script ClosePropertiesBox (); {Control+Shift+C}

; Used to close a properties box.

if	FindGraphic (GetFocus(), "Close Properties", S_top, S_UnRestricted) == 1 then
	LeftMouseButton()
else
	Beep()
endif

PcCursor()

EndScript

Script DesignMode (); {control + shift + d}

; Attempt to find the word design on the screen and click on it
; This opens or closes design mode.

let GlobalFindWhat = msg055 ; "Design"

PerformScript nlnotes15()

EndScript

Script DevelopForms (); {control + shift + f}


; Attempt to find the word Forms on the screen and click on it.
; In design mode, this opens up the list box of forms.
; You can then select one to edit

let GlobalFindWhat = msg057 ; " Forms"

PerformScript nlnotes15()

EndScript

Script DevelopViews (); {control + shift + v}


; Attempt to find the word Views on the screen and click on it.
; In design mode, this opens up the list box of views.
; You can then select one to edit

let GlobalFindWhat = msg060 ; "Views"

PerformScript nlnotes15()

EndScript


Script DevelopAgents ()

; Attempt to find the word agents on the screen and click on it.
; In design mode, this opens up the list box of agents.
; You can then select one to edit.

let GlobalFindWhat = msg062 ; "Agents"

PerformScript nlnotes15()

EndScript

Script DevelopSharedFields ()

let GlobalFindWhat = msg064 ; "Shared F"

PerformScript nlnotes15()


EndScript


Script DevelopSubForms (); {control + shift + s}


; Attempt to find the word Subforms on the screen and click on it
; In design mode, this opens up the list box of subforms .
; You can then select one to edit

let GlobalFindWhat = msg065 ; "Subforms"

PerformScript nlnotes15()

EndScript

Script DevelopOther (); {control + shift + s}


; Attempt to find the word Other on the screen and click on it
; In design mode, this opens up the list box of Other elements.
; You can then select one to edit

let GlobalFindWhat = msg066 ; "Other"

PerformScript nlnotes15()

EndScript


Script DevelopNavigators ()

; Attempt to find the word Navigators on the screen and click on it
; In design mode, this opens up the list box of navigators.
; You can then select one to edit

let GlobalFindWhat = msg067 ; "Navigators"

PerformScript nlnotes15()



EndScript


;Script EditDefinitions (); {alt + control + shift + d}

;var
;	int Found
;  Attempt to jump to the Define combobox
; Click if found.

;if	GlobalMenuMode > MENU_INACTIVE then
;	return
;endif

;if	DialogActive() then
;	return
;endif

;let Found = GoToControl(100, True) 

;if	Found > 0 then
;	SayString(msg070) ; "Define:"
;	return
;endif

;Beep()

;EndScript
Script EditDefinitions ()

; Attempt to find the word Define.
; If found, does a word right to get to the word that opens up
; the Define combo  box. Does a next word, 
; Then does a mouse click to open up the box.
; Used when writing formulas, scripts, and so on for fields, 
; forms, subforms, and views.
; You can then select one to write formulas or scripts for it.

let GlobalFindWhat = msg070 ; "Define:"

PerformScript nlnotes20()

EndScript

Script nlnotes20(); {Insert + alt + control + f}

; Attempt to find a word on the screen, do a word right, and 
; click.
; turn on read labels if found
; and execute reading the label and the field. 
; Turn read labels back off.

var
	handle Window
;	string class

let Window = GetFocus()
; let Window = GetParent (Window)
MoveToWindow(Window)
;JawsCursor()
;let class = GetWindowClass(Window)
; SayString (Class)

if	(FindString (Window, GlobalFindWhat, s_BOTTOM, s_UNRESTRICTED)) then
	NextWord ()
	LeftMouseButton ()
;	let ReadLabels = ON
;	PerformScript nlnotes6()
;	let ReadLabels = OFF
	SayString(GlobalFindWhat)
else
	Beep()
endif

PcCursor()

EndScript

Script EditEvents (); {alt + control + shift + e}

var
	int Found
;  Attempt to jump to the Events combobox
; Click if found.

if	GlobalMenuMode > MENU_INACTIVE then
	return
endif

if	DialogActive() then
	return
endif

let Found = GoToControl(101, True) 

if	Found > 0 then
	SayString(msg075) ; "Events:"
	return
endif

Beep()



EndScript

Script nlnotes15(); {Insert + alt + f}


; Attempt to find a word on the screen and click.

var
	handle Window,
	string class

let Window = GetFocus()
let Window = GetParent (Window)
MoveToWindow(Window)
JawsCursor()
let class = GetWindowClass(Window)
; SayString (Class)

if	(FindString (Window, GlobalFindWhat, s_BOTTOM, s_UNRESTRICTED)) then
	PriorLine()
	LeftMouseButton ()
	SayString(GlobalFindWhat)
else
	Beep()
endif

PcCursor()

EndScript

;Script HotKeyHelp(); {insert + h}


;SayString(msg201) ; "To read the current document screen use control + shift + down arrow"
;SayString(msg205) ; "To scroll through documents use page up and dpage down"
;SayString(msg207) ; "To close a properties box use control + shift + c"
;SayString(msg210) ; "Jaws special database development and reading keys"
;	SayString(msg215) ; "To move to the left pane of a split screen use insert + control + the letter e"
;SayString(msg220) ; "To move to the right pane of a split screen use insert + control + r"
;	SayString(msg225) ; "To return to full screen use control + shift + w"
;SayString(	msg230) ; "When designing databases use the following Jaws keys"
;SayString (msg235) ; "To open up design mode use control + shift + d"
;SayString(msg240) ; "Once in design mode use the following keys"
;SayString(	msg245) ; "To open up the forms list box use control + shift + f"
;SayString(	msg250) ; "To open up the sub forms list box use control + shift + s"
;SayString(msg255) ; "to open up the views list box use control + shift + v"
;SayString(msg260) ; "When editing forms, sub forms and views use the following Jaws keys"
;SayString(	msg265) ; "To open the define fields list box use alt + control + shift + d"
;SayString(msg270) ; "To open the events list box use alt + control + shift + e"

;EndScript


Script ScriptFileName(); {Insert+Q}


If  (GetVerbosity() == beginner) Then
    SayString("The script file currently being used is ")
EndIf

SayString("NlNotes.jms")

If  (GetVerbosity() == beginner) Then
    SayString ("The application currently being used is ")
EndIf

SayString (GetAppFileName ())
SpellString (GetAppFileName ())
SayString ("scripts written for jfw 3.x")
SayString("version 2 by jim homi")
EndScript


Script ReadHelpText ()

var
	handle Window,
	string TheClass

let Window = GetFocus()
let Window = GetNextWindow(Window)
let TheClass = GetWindowClass(Window)

if	TheClass == "NotesFieldHelp" then
	SayWindow (Window, Read_everything)
else
	SayString("help text not found")
endif

EndScript


Script ReadFormulaWindow ()

var
	int Found
;  attempt to find the formula or script window
; Click if found.

let found = GoToControl (200, True) 

if	Found > 0 then
	SayString ("formula window")
	PcCursor()
	return
endif

let found = GoToControl (106, True) 

if	Found > 0 then
	SayString ("formula window")
	PcCursor()
	return
endif

let Found = GoToControl(350, True) 

if	Found > 0 then
	SayString ("formula window")
	PcCursor()
	return
endif

SayString ("could not find formula window")

EndScript


Int Function GoToControl (int ControlId, int Click)

var
	handle Window,
	int found

let Window = GetFocus()
let Window = GetParent(Window)

let found = MoveToControl (Window, ControlId) 

if	Found > 0 then
		If	Click == True then
		LeftMouseButton()
	endif
endif

let Window = GetParent(Window)

if	Found > 0 then
		If	Click == True then
		LeftMouseButton()
	endif
endif

return Found

EndFunction


Script ReadingModeToggle ()

if	GlobalReadMode == on then
	let GlobalReadMode = off
	SayString ("automatic reading off")
else
	let GlobalReadMode = on
	SayString ("automatic reading on")
endif

let GlobalPrevReadMode = GlobalReadMOde
EndScript

Script UpALevel() 

var
	int TheTypeCode
{Escape}
pause()
SaveCursor()
PCCursor()
let TheTypeCode = GetWindowSubTypeCode (GetCurrentWindow())
If (TheTypeCode == WT_MENU) then
	SayString (msg3) ;"Menu"
	SayWindow (GetCurrentWindow(), READ_HIGHLIGHTED)
	return
EndIf
if (TheTypeCode == WT_STARTMENU) then
	SayString (msg4) ;"Start Menu"
	SayWindow (GetCurrentWindow(), READ_HIGHLIGHTED)
	return
EndIf
if (TheTypeCode == WT_CONTEXTMENU) then
	SayString (msg5) ;"Context Menu"
	SayWindow (GetCurrentWindow(), READ_HIGHLIGHTED)
EndIf

ToggleJawsRestriction(off)

EndScript	



Script ReadDocumentScreen ()

ScreenOrActionBar(1)
EndScript


Script GoToActionBar ()

ScreenOrActionBar(0)
JawsCursor()

EndScript


Void Function ScreenOrActionBar (int Action)

if	Action == 1 then
	if	GetWindowClass(GetCurrentWindow()) != WC01 then  ; "NotesRichText"
		Beep()
		RestoreCursor()
		return
	endif
endif
 
if	Action == 1 then
	SaveCursor()
	InvisibleCursor()
	RouteInvisibleToPc()
	ToggleJawsRestriction(on)
	JawsPageUp()
	SayToBottom ()
	RestoreCursor()
	ToggleJawsRestriction(off)
	return
endif	

if	Action == 0 then
	if	not IsJawsCursor() then
		JawsCursor() 
	endif
	RouteJawsToPC() 
	ToggleJawsRestriction(off)
	JawsPageUp() 	
	NextLine() 
	NextLine() 
	JawsHome() 
	if	GetWindowClass(GetParent(GetCurrentWindow())) ==  "ActionBar" then
	SayWord()
	return
	else
		Beep()
		return
	endif
endif

EndFunction

Script JawsCursor ()

var
	int Cursor

ResetSynth()
let Cursor = GetActiveCursor()

if (IsSameScript ()) then
	InvisibleCursor()
	SayString (msg11) ;"invisible Cursor"
	return
else
	JawsCursor()
endif

if  AutoRouteJAWSToPc == on
&&	Cursor != Cursor_Jaws then
  RouteJAWSToPc ()
endif

SayString(msg13) ;"JAWS Cursor"

EndScript

Script ToggleAutoRoute ()

if	AutoRouteJAWSToPc == on then
	SayString(msg501)  
	let AutoRouteJAWSToPc = off
else
	SayString(msg505)
	let AutoRouteJAWSToPc = on
EndIf

EndScript


Void Function ToggleJawsRestriction (int Restrict)

if	ToggleRestriction() != Restrict then
	ToggleRestriction()
endif

EndFunction
