Include "nnotesws.jsh"
; Script file: NNOTESWS.JSS.
; Script file for lotus notes R 4.x.
; Program file: NNOTESWS.DLL.
; Part of the set of lotus notes macro files.
; Author: Jim Homme.
; Date Written: October 21, 1996.
; Modified for Lotus Notes Release 4.5 April 2, 1997.
; Last modified: March 17, 1998.
; Last modification:  Added NewTextEvent and related functions.

include "hjconst.jsh"
include "hjglobal.jsh"
include "notesws.jsm"

globals
	int DefaultFirstTime

Void Function AutoStartEvent ()
FrameClearValues ()
SayString(GetAppFileName())
if (DefaultFirstTime == Off) then
	let DefaultFirstTime = 1
	If (GetVerbosity() == BEGINNER) then
		SayString (msg000) ;"for screen sensitive help Press insert + f1"
		SayString (msg002) ;"for JAWS Help Keys or help in dialog boxes Press Insert + H"
		SayString (msg003) ; "Press insert + w for useful Windows keys"
	EndIf
endif ;DefaultFirstTime == 0

let GlobalReadMode = on

EndFunction

Function SayFocusedWindow(); {Insert+;}

if	DialogActive() then
	let GlobalSpeek = QUIET
	PerformScript ActivateFullScreen()
	let GlobalSpeek = SPEEK
endif

if	ReadLabels == OFF then
	SayWindowTypeAndText(GlobalFocusWindow)
endif

EndFunction

Void Function NewTextEvent (handle hwnd, string buffer, int nAttributes, 
int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

var
	string TheClass

let TheClass = GetWindowClass(hwnd)

;if	TheClass == "NotesSubprog" then
;	SayString(buffer)
;	SayInteger(nTextColor)
;	SayString("on")
;	SayInteger(nBackgroundColor)
;endif

if	sFrameName == "" then
	; this text is not associated with a frame
	SayNonFramedText (hwnd, buffer, nAttributes, 
	nTextColor, nBackgroundColor, nEcho, sFrameName)
else
	; this text is associated with a frame
	if (nEcho == ECHO_NONE) then
		return; frame is being silenced
	endif
	if (nEcho  == ECHO_ALL ||
	   (nAttributes & ATTRIB_HIGHLIGHT)) then
		; if FrameEcho is set to all or the text being written is highlighted
		SayString(buffer)
	endif
endif

EndFunction

Void Function SayNonFramedText (handle hwnd, string buffer, int nAttributes, 
int nTextColor, int nBackgroundColor, int nEcho, string sFrameName)

var
	string TheClass

if	(nAttributes& ATTRIB_HIGHLIGHT) then
	let SayHighlightedTextCalled = true
	SayHighlightedText(hwnd,buffer)
	return
endif

let TheClass = GetWindowClass(hwnd)

if	nTextColor == 33534432  then
	if	TheClass == "NotesSubprog"   then
		let SayHighlightedTextCalled = true
;		SayString ("highlighted") 
;		SayInteger(nTextColor)
;		SayString ("on")
;		SayInteger(nBackgroundColor)
		SayHighlightedText(hwnd,buffer)
		return
	endif
endif

;if	nTextColor == 33554432  then
;	if	TheClass == "NotesSubprog"   then
;		let SayHighlightedTextCalled = true
;		SayString ("highlighted") 
;		SayInteger(nTextColor)
;		SayString ("on")
;		SayInteger(nBackgroundColor)
;		SayHighlightedText(hwnd,buffer)
;		return
;	endif
;endif

if	nTextColor == 50331647 then
	if	TheClass == "ListBox"   then
		let SayHighlightedTextCalled = true
		SayHighlightedText(hwnd,buffer)
		return
	endif
endif

;if TheClass == "NotesFieldHelp" then
;	SayString(buffer)
;	return
;endif

SayNonHighlightedText(hwnd,buffer)

EndFunction

Function SayHighlightedText(handle hwnd,string buffer)

if	(HasFocusRect(hwnd) 
&&	GetScreenEcho() > ECHO_NONE) then
	SayString (Buffer)
	return
endif

; This code was originally in this macro.
; It executes if there's highlihgted text and no focus rect.

if	(GetScreenEcho() > ECHO_NONE) Then 
	SayString(Buffer)
endif

EndFunction

Void Function SayNonHighlightedText (handle hwnd, string buffer)
	var
	string TheClass
let TheClass = GetWindowClass(hwnd)
if ((GetScreenEcho() > 1)

   || (TheClass == wc04 )) then
	SayString(buffer)
EndIf
;Obtains tool tip window handle when appears, zero is return if not found.

if	TheClass ==  WC01 ; "NotesRichText"
&&	GlobalReadMode == on then
	SayString(buffer) 
	return
endif

If (TheClass == "tooltips_class32") Then
	let ToolTipsHandle = Hwnd 
	;the if test works only when the jaws cursor is active.
	;To allow the tool tip to be spoken when it is moving across the task tray.
	if (GetActiveCursor () == 0) Then 
	SayWindow (ToolTipsHandle, 0)
	endif
endif
if (GetWindowSubtypeCode (Hwnd) == WT_PASSWORDEDIT) then ;#42
	SayString (buffer)
EndIf
if (GetWindowSubTypeCode (hwnd) == WT_TREEVIEW) && (GetTreeViewLevel() !=PreviousTreeviewLevel) then
	SaytreeViewLevel ()
endIf

EndFunction

Function BottomEdgeEvent(handle WindowHandle)

Var
	int Verbosity

; SayString("bottom edge macro")

let Verbosity = GetVerbosity ()
let GlobalBottomEdge = ON ; Set indicator to stop nextline moves down.

if Verbosity == BEGINNER then
	SayString (msg030) ; "Bottom of window"
endif

if Verbosity == INTERMEDIATE then
SayString (SubString (msg030, 1, 6))
endif

Beep ()

EndFunction

Function MenuModeHook()

PerformScript nnotesws2()

EndFunction

; Reading Keys Macros

Script SayNextLine()


NextLine()

PerformScript nnotesws3()

EndScript

Script SayPriorCharacter()


PriorCharacter ()

PerformScript nnotesws4()

EndScript

Script SayNextCharacter(); {Right Arrow}

NextCharacter()

PerformScript nnotesws4()

EndScript

Script SayPriorLine()


PriorLine()

PerformScript nnotesws3()

EndScript

Script nnotesws5 ()


{Tab}

if	CaretVisible() then
;	SayString("Caret visible")
	SayField()
	return
endif

PerformScript nnotesws6()

EndScript

Script nnotesws7()


{Shift+Tab}

if	CaretVisible() then
;	SayString("Caret visible")
	SayField()
	return
endif

PerformScript nnotesws6()

EndScript

Script nnotesws8()


{Enter}

if	CaretVisible() then
;	SayString("Caret visible")
	SayField()
	return
endif

PerformScript nnotesws6()

EndScript

;Script JawsPageDown(); {Page Down}

;SayString(msg035); "Page down"
;JAWSPageDown()

;if	not IsPcCursor() then
;	return
;endif

; Set up scrolling.

;let GlobalFindWhat = msg040 ; "Bottom of document"
;let GlobalPrevTopLine = GlobalTopLine
;let GlobalPrevBottomLine = GlobalBottomLine
;let GlobalScrolling = ON

;PerformScript nnotesws9()

;let GlobalScrolling = OFF

;EndScript

;Script JawsPageUp(); {Page Up}

;SayString(msg045); "Page up"
;JAWSPageUp()

;If	not IsPcCursor() then
;	return
;endif

; Set up scrolling

;let GlobalFindWhat = msg050 ; "Top of document"
;let GlobalPrevTopLine = GlobalTopLine
;let GlobalBottomLine = GlobalPrevBottomLine
;let GlobalScrolling = ON

;PerformScript nnotesws9()

;let GlobalScrolling = OFF

;EndScript

;Script nnotesws9(); {Control + Shift + DownArrow }

; Read only the text information in documents.
; Skip over menu, ToolBar, ActionBar.

; Assume we are not at the bottom, yet.

;let GlobalBottomEdge = OFF

;InvisibleCursor()
;RouteInvisibleToPc()
;JawsPageUp()
;NextLine()
;NextLine()
;NextLine()
;NextLine()

;let GlobalTopLine = GetLine()

; If this macro executes as a result of someone pressing control + shift + downarrow,
; Scrolling will be off, and the document screen will be read.

;if	GlobalScrolling == OFF then
;  	SayString("scrolling is off")
;	PerformScript nnotesws10() ; Say the text in the window.
;	PcCursor()
;	return
;endif

; Skip white space and populate GlobalTopLine.

;While((GlobalTopLine == " ") && (GlobalBottomEdge == OFF)) ; Skip Blank lines at the top.

;	NextLine()
;	let GlobalTopLine =  GetLine()
;endwhile 

;if	GlobalTopLine == GlobalPrevTopLine then
;	SayString(GlobalFindWhat)
;	PcCursor()
;	return
;endif
; Now, since we've found the right window, Let's read.

;PerformScript nnotesws10()

;PcCursor()

;EndScript

;Script nnotesws10() 

;var
;	handle window,
;	string Class,
;	string PrevClass

;let Window = GetCurrentWindow()
;let Class = GetWindowClass(Window)
;let PrevClass = Class

;while((Class == PrevClass) && ( GlobalBottomEdge == OFF))

;	SayLine()
;	NextLine()
;	let Window = GetCurrentWindow()
;	let Class = GetWindowClass(Window)

;endwhile

;EndScript

Script nnotesws3(); {insert+control+shift+f11}


; This scriptgets called when the up or down arrow is pressed.

pause()


if	not IsPCCursor() then ; Another cursor is active 
;	SayString("not pc cursor")
	SayLine()
	return
endif

if	CaretVisible() then
;	SayString("caret visible")
   SayLine()
	return 
endif

PerformScript nnotesws6()

EndScript

Script nnotesws4()



; This macro gets called when the left or right arrow is pressed.

if	not IsPCCursor() then
	SayCharacter()
	return
endif

if	CaretVisible() then
	SayCharacter()
	return
endif

PerformScript nnotesws6()

EndScript

Script nnotesws6()


var
	handle Window,
	string Class


let Window = GetCurrentWindow()
Let Class = GetWindowClass(Window)

; SayString (Class)
; Refresh()

if	(ReadLabels == on) then
;	SayString("Read labels is on")
	SayToCursor ()
endif

if	(GetWindowTypeCode(Window) == WT_TABCONTROL) then
; 	SayString("Tab control")
	SayWord()
	return
endif

PerformScript nnotesws2()

EndScript

Script nnotesws2()

; Force JFW to speak in some windows when direction keys are pressed.

var
	handle Window,
	int ControlId,
	string WindowClass

let Window = GetCurrentWindow()
let WindowClass = GetWindowClass(Window)
let ControlId = GetControlId(Window)

; SayString ("control id ") SayInteger(ControlId)

if	((WindowClass == WC03) ; "NotesSubprog")
&&	(ControlId == 1)) then
	SayFromCursor()
 	return
endif

if	ControlId == 163 then
	SayLine()
	return
endif

if	ControlId == 653 then
	SayLine()
	return
endif


if	ControlId == 419 then
	SayLine()
	return
endif

if	ControlId == 1002 then
	SayLine()
	return
endif

if	((WindowClass == WC03) ; "NotesSubprog"
&&	(ControlId == 1001)) then
	SayFromCursor()
endif


EndScript

Script ActivateLeftPane ()


; Move to the left pane.

if	GlobalMenuMode > MENU_INACTIVE then
	Beep()
	return
endif

if	DialogActive() then
	Beep()
	return
endif

if	GlobalPane == LeftPane then
	SayString(msg085) ; "Already on left pane"
	return
endif

JawsCursor()
RouteJawsToPc()
JawsPageUp()
JawsHome()
NextLine()
NextLine()
NextLine()
NextLine()
NextLine()
Nextline()
Nextline()

if	ToggleRestriction() then ; We were in full screen
	JawsPageup()
	JawsHome() ; Get on something to click on.
	SayString(msg080) ; " left pane"
	SayLine()
	let GlobalPane = LeftPane
else ; We came from the right pane to the left pane,
	PerformScript ActivateLeftPane() ; re-position
endif

EndScript

Script ActivateRightPane ()


; Move to the right pane.

if	GlobalMenuMode > MENU_INACTIVE then
	Beep()
	return
endif

if	DialogActive() then
	Beep()
	return
endif

if	GlobalPane == RightPane then
	SayString(msg095) ; "Already on right pane"
	return
endif

JawsCursor()
RouteJawsToPc()
JawsPageUp()
JawsEnd()
NextLine()
NextLine()
NextLine()
NextLine()
NextLine()
NextLine()
NextLine()

if	ToggleRestriction() then ; We were in full screen
	JawsPageup()
	JawsHome() ; Get on something we can click on.
	SayString(msg090) ; " Rightt pane"
	SayLine()
	let GlobalPane = RightPane
else ; We came from the left pane to the right pane,
	PerformScript ActivateRightPane() ; re-position
endif

EndScript

Script ActivateFullScreen ()


; Set back to full-screen mode.

PCCursor()

if ToggleRestriction() then
	ToggleRestriction() ; Make sure restriction is off.
endif

if	GlobalSpeek == SPEEK then
	SayString ("full screen")
endif

let GlobalPane = FullScreen

EndScript

Script LeftMouseButton(); {num pad slash}


LeftMouseButton()

if	IsSameScript() then
	let GlobalSpeek = QUIET
	PerformScript ActivateFullScreen()
	let GlobalSpeek = SPEEK
endif

EndScript

; ScriptsFor Notes Database Developers

Script nnotesws13(); {Control+Shift+C}


; Used to close a properties box.

if	not IsJawsCursor() then
	JawsCursor()
endif

JawsPageUp()
JawsEnd()
LeftMouseButton ()

if	not IsPcCursor() then
	PcCursor()
endif

EndScript

Script DesignMode (); {control + shift + d}


; Attempt to find the word design on the screen and click on it
; This opens or closes design mode.

let GlobalFindWhat = msg055 ; "Design"

PerformScript nnotesws15()

EndScript

Script DevelopForms (); {control + shift + f}


; Attempt to find the word Forms on the screen and click on it.
; In design mode, this opens up the list box of forms.
; You can then select one to edit

let GlobalFindWhat = msg057; " Forms"

PerformScript nnotesws15()

EndScript

Script DevelopViews (); {control + shift + v}


; Attempt to find the word Views on the screen and click on it.
; In design mode, this opens up the list box of views.
; You can then select one to edit

let GlobalFindWhat = msg060 ; "Views"

PerformScript nnotesws15()

EndScript

Script DevelopSubForms (); {control + shift + s}


; Attempt to find the word Subforms on the screen and click on it
; In design mode, this opens up the list box of subforms .
; You can then select one to edit

let GlobalFindWhat = msg065 ; "Subforms"

PerformScript nnotesws15()

EndScript


Script DefineElements (); {alt + control + shift + d}


; Attempt to find the word Define.
; If found, does a word right to get to the word that opens up
; the Define combo  box. Does a next word, 
; Then does a mouse click to open up the box.
; Used when writing formulas, scripts, and so on for fields, 
; forms, subforms, and views.
; You can then select one to write formulas or scripts for it.

let GlobalFindWhat = msg070 ; "Define:"

PerformScript nnotesws20()

EndScript

Script EventAssociations (); {alt + control + shift + e}


; Attempt to find the word Event.
; If found, does a word right to get to the word that opens up
; the events combo  box. 
; Then does a mouse click to open up the box.
; Used when writing formulas, scripts, and so on for fields, 
; forms, subforms, and views.
; You can then select one to edit

let GlobalFindWhat = msg075 ; "Event:"

PerformScript nnotesws20()

EndScript
Script nnotesws15(); {Insert + alt + f}


; Attempt to find a word on the screen and click.

var
	handle Window

let Window = GetFocus()
MoveToWindow(Window)
if	(FindString (Window, GlobalFindWhat, s_BOTTOM, s_UNRESTRICTED)) then
	LeftMouseButton ()
	SayString(GlobalFindWhat)
	PcCursor()
	return
else
	Beep()
endif

let Window = GetFocus()
MoveToWindow(Window)

if	(FindString (Window, GlobalFindWhat, s_TOP, s_UNRESTRICTED)) then
	LeftMouseButton ()
	SayString(GlobalFindWhat)
	return
else
	Beep()
endif

EndScript

Script nnotesws20(); {Insert + alt + control + f}


; Attempt to find a word on the screen, do a word right, and 
; click.
; turn on read labels if found
; and execute reading the label and the field. 
; Turn read labels back off.

var
	handle Window

let Window = GetFocus()

MoveToWindow(Window)

if	(FindString (Window, GlobalFindWhat, s_Bottom, s_UNRESTRICTED)) then
	NextWord ()
	LeftMouseButton ()
;	SayString("found" + GlobalFindWhat)
	let ReadLabels = ON
	PerformScript nnotesws6()
	let ReadLabels = OFF
else
	Beep()
endif

PcCursor()

EndScript

Script HotKeyHelp(); {insert + h}


SayString(msg201) ; "To read the current document screen use control + shift + down arrow"
SayString(msg205) ; "To scroll through documents use page up and dpage down"
SayString(msg207) ; "To close a properties box use control + shift + c"
SayString(msg210) ; "Jaws special database development and reading keys"
	SayString(msg215) ; "To move to the left pane of a split screen use insert + control + the letter e"
SayString(msg220) ; "To move to the right pane of a split screen use insert + control + r"
	SayString(msg225) ; "To return to full screen use control + shift + w"
SayString(	msg230) ; "When designing databases use the following Jaws keys"
SayString (msg235) ; "To open up design mode use control + shift + d"
SayString(msg240) ; "Once in design mode use the following keys"
SayString(	msg245) ; "To open up the forms list box use control + shift + f"
SayString(	msg250) ; "To open up the sub forms list box use control + shift + s"
SayString(msg255) ; "to open up the views list box use control + shift + v"
SayString(msg260) ; "When editing forms, sub forms and views use the following Jaws keys"
SayString(	msg265) ; "To open the define fields list box use alt + control + shift + d"
SayString(msg270) ; "To open the events list box use alt + control + shift + e"

EndScript


Script ScriptFileName(); {Insert+Q}


var
	int V

let V = GetVerbosity()

If  (V == beginner) Then
    SayString(msg001) ; "The script file currently being used is ")
EndIf

SayString(msg004) ; "NNOTESWS.JMS"

If  (V == beginner) Then
    SayString (msg010) ; "The application currently being used is ")
EndIf

SayString (GetAppFileName ())
SpellString (GetAppFileName ())

EndScript

Script ReadingModeToggle ()

if	GlobalReadMode == on then
	let GlobalReadMode = off
	SayString ("automatic reading off")
else
	let GlobalReadMode = on
	SayString ("automatic reading on")
endif

EndScript